# Syntax coloring rules for 'C#'
# January 23, 2010  FEA

addsyntaxmap "C#" \
{
	exp {e_types				"<(bool|byte|sbyte|char|decimal|double|float|int|uint|long|ulong|object|short|ushort|string)>"}
	exp {e_keywords				"<(abstract|event|new|struct|as|explicit|null|switch|base|extern|this|false|operator|throw|break|finally|out|true|fixed|override|try|case|params|typeof|catch|for|private|char|foreach|protected|checked|goto|public|unchecked|class|if|readonly|unsafe|const|implicit|ref|continue|in|return|using|virtual|default|interface|sealed|volatile|delegate|internal|void|do|is|sizeof|while|double|lock|stackalloc|else|static|enum|namespace|add|from|get|global|group|into|join|let|orderby|partial|partial|remove|select|set|value|var|where|yield)>"}
	exp {e_directive_intro		"^\[ \\t\]*#"}
	exp {e_directive_include	"<include>"}
	exp {e_directive_others		"<(if|else|elif|endif|define|undef|warning|error|line|region|endregion|pragma|pragma warning|pragma checksum)>"}
	exp {e_include_quote_start	"\\<"}
	exp {e_include_quote_end	"\\>"}
	exp {e_comment_start		"/\\*"}
	exp {e_comment_end			"\\*/"}
	exp {e_alt_comment_start	"//"}
	exp {e_end_of_line			"$"}
	exp {e_string_delimiter		"\""}
	exp {e_quoted_char			"(\\\\)(\[-\])"}
	exp {e_char_delimiter		"'"}

	map {m_keywords				e_keywords				{}									$style_keyword		0				0}
	map {m_types				e_types					{}									$style_type			0				0}
	map {m_directive			e_directive_intro		{e_end_of_line}						$style_directive	0				0}
	map {m_directive_include	e_directive_include		{e_end_of_line}						$style_directive	0				0}
	map {m_directive_others		e_directive_others		{}									$style_directive	0				0}
	map {m_include_quote		e_include_quote_start	{e_include_quote_end}				$style_delimiter	$style_string	$style_delimiter}
	map {m_quoted_char			e_quoted_char:0			{e_quoted_char:1}					$style_delimiter	0				$style_char}
	map {m_comment				e_comment_start			{e_comment_end}						$style_comment		$style_comment	$style_comment}
	map {m_alt_comment			e_alt_comment_start		{e_end_of_line}						$style_comment		$style_comment	$style_comment}
	map {m_string				e_string_delimiter		{e_string_delimiter}				$style_delimiter	$style_string	$style_delimiter}
	map {m_char					e_char_delimiter		{e_char_delimiter}					$style_delimiter	$style_char		$style_delimiter}

	at {m_directive				{m_quoted_char m_directive_include m_directive_others m_keywords m_types m_comment m_alt_comment m_string m_char}}
	at {m_directive_include		{m_quoted_char m_keywords m_types m_comment m_alt_comment m_string m_include_quote m_char}}
	at {m_include_quote			{m_quoted_char}}
	at {m_string				{m_quoted_char}}
	at {m_char					{m_quoted_char}}

	root {m_quoted_char m_directive m_keywords m_types m_comment m_alt_comment m_string m_char}
}

set	extensionHuntExpression(C#)	{^((.*\.cs))$}
set	extensionTabSize(C#)		4
set	extensionColorScheme(C#)	"e93"
set	extensionMapName(C#)		"C#"



